//  SPDX-FileCopyrightText: 2023 Yury Gubich <blue@macaw.me>
//  SPDX-License-Identifier: GPL-3.0-or-later

#pragma once

#include <string>

#include "request/accepting.h"

class Session : public Accepting {
public:
    Session(unsigned int id, const std::string& access, const std::string& renew);
    Session(const Session&) = delete;
    Session(Session&& other);
    Session& operator = (const Session&) = delete;
    Session& operator = (Session&& other);

    std::string getAccessToken() const;
    std::string getRenewToken() const;
    void accept(std::unique_ptr<Request> request) override;

private:
    unsigned int id;
    std::string access;
    std::string renew;
    std::unique_ptr<Request> polling;
};
